<?php
function test_braintree_connection(){
	$environment = $_POST['environment'];
	$merchantId = $_POST['merchantId'];
	$publicKey = $_POST['publicKey'];
	$privateKey = $_POST['privateKey'];

	$args = array('environment'=>$environment,
			'merchantId'=>$merchantId,
			'publicKey'=>$publicKey,
			'privateKey'=>$privateKey
	);
	$result = Braintree_Donations::test_braintree_connection($args);

	echo json_encode($result);
	wp_die();
}
add_action('wp_ajax_test_braintree_connection', 'test_braintree_connection');

function activate_braintree_payments_license(){
	$license_key = $_POST['braintree_license_activation_key'];

	$api_params = array('slm_action'=>'slm_activate',
			'secret_key'=>BRAINTREE_LICENSE_VERIFICATION_KEY,
			'license_key'=>$license_key
				
	);
	$response = wp_remote_get(add_query_arg($api_params, BRAINTREE_LICENSE_ACTIVATION_URL), array('timeout' => 20, 'sslverify' => false));

	if(is_wp_error($response)){
		return new WP_Error('error', 'Your license could not be
				activated at this time. Please email mr.clayton@bradstreet.co for activation.');
	}

	$response['body'] = json_decode($response['body']);

	if(is_wp_error($response)){
		update_braintree_payments_config('braintree_payments_license_status', 'inactive');
		return new WP_Error('error', $response['body']->message);
	}

	if($response['body']->result == 'success'){
		update_braintree_payments_config('braintree_payments_license_status', 'active');
		update_braintree_payments_config('braintree_payments_license', $license_key);
		update_braintree_payments_config('braintree_next_license_check', (time()+5*24*3600));
		return true;
	}
	else {
		return new WP_Error('error', 'Your license key is incorrect.');
	}


}
add_filter('activate_braintree_payments_license', 'activate_braintree_payments_license');

function update_braintree_payments_config($option, $value){
	$option = base64_encode($option);
	update_option($option, base64_encode(maybe_serialize($value)));
}
function get_braintree_payments_config($option){
	$option = base64_encode($option);
	return maybe_unserialize(base64_decode(get_option($option)));
}
function get_braintree_subscription_plans(){
	$config = [];
	$config['api_keys'] = maybe_unserialize(get_braintree_payments_config('braintree_api_keys_config'));
	$config['merchant_accounts'] = maybe_unserialize(get_braintree_payments_config('braintree_merchant_account_id_config'));
	$environment = $config['api_keys']['environment'];
	
	Braintree_Configuration::environment($environment);
	Braintree_Configuration::merchantId($config['api_keys'][$environment]['merchantId']);
	Braintree_Configuration::publicKey($config['api_keys'][$environment]['public_key']);
	Braintree_Configuration::privateKey($config['api_keys'][$environment]['private_key']);
	
	try {
		return Braintree_Plan::all();
	} catch(Exception $e){
		
	}
			
			
		
}
?>