<?php
/**
 * Sends the payment form and client token to the broweser.
 */
function do_braintree_donation_short_code(){

	wp_enqueue_style('braintree-payments-styles', BRAINTREE_PAYMENTS_ASSETS.'css/braintree-payments.css');
	wp_enqueue_script('braintree-script', 'https://js.braintreegateway.com/v2/braintree.js');
	wp_enqueue_script('braintree-payments-script', BRAINTREE_PAYMENTS_ASSETS.'js/braintree-payments.js', array('jquery', 'braintree-script'));
	
	$braintree_donation = new Braintree_Donations();
	
	
	$html = $braintree_donation->get_donation_form().' '.$braintree_donation->get_donation_button();

	return $html;
	?>
	
	
	
	<?php
}
add_shortcode('braintree_donations', 'do_braintree_donation_short_code');

/**
 * Process the donation payment via ajax. 
 */
function braintree_process_donation_payment(){
	$response = array();
	if(! isset($_POST['action'])){
		$response['error'] = '404';
		$response['error']['message'] = __('Please resubmit your payment', 'Braintree_Donations');
		echo json_encode($response);
		wp_die();
	}
	else if(! isset($_POST['donation_amount'])){
		$response['error'] = '404';
		$response['error']['message'] = __('Please enter a donation amount', 'Braintree_Donations');
		echo json_encode($response);
		wp_die();
		
	}
	$response = apply_filters('process_braintree_donation_payment');
		/* if(empty($response)){
			$response['code'] = '401';
			$response['error']['message'] = 'There was an issue processing the payment';
		}
	echo json_encode($response); */
	echo $response;
	wp_die();
}
add_action('wp_ajax_braintree_process_donation_payment', 'braintree_process_donation_payment');

/**
 * Function that processes the donation payment
 */
function process_braintree_donation_payment(){
	if(class_exists('Braintree_Donations')){
		$braintree_donation = new Braintree_Donations();
		
		$result = $braintree_donation->process_payment();
		
		if(is_a($result, Exception)){
			$response = '<div class="braintree-donations-message is-failure">
			<img class="close-icon-failure" src="'.BRAINTREE_PAYMENTS_ASSETS .'images/close-donation.png"/>
			<p>'. __('Your payment cannot be processed at this time.', 'Braintree_Donations').'</p></div>';
			}
		
	else if($result->success){
			$response = '<div class="braintree-donations-message is-success">
			<img class="close-icon-success" src="'.BRAINTREE_PAYMENTS_ASSETS .'images/close-donation.png"/>
			<p>'.__($braintree_donation->get_config()['messages']['donation_message'], 'Braintree_Donations').'</p></div>';
		}
		else if ($result->errors->deepSize() > 0){
			$response = '<div class="braintree-donations-message is-failure">
				<img class="close-icon-failure" src="'.BRAINTREE_PAYMENTS_ASSETS .'images/close-donation.png"/>';
			foreach($result->errors->deepAll() as $error){
				$response .= '<p>'.$error->message.'</p>';
			}
			$response .= '</div>';
		}
		else {
			if($_POST['payment_type'] == 'PayPalAccount'){
				$message = $result->transaction->processorResponseText;
			}
			$response = '<div class="braintree-donations-message is-failure">
			<img class="close-icon-failure" src="'.BRAINTREE_PAYMENTS_ASSETS .'images/close-donation.png"/>
			<p>'.$result->transaction->processorSettlementResponseCode.'</p>
			<p>'.$result->transaction->processorSettlementResponseCode.'</p>
						<p>'.$message.'</p></div>';
		}
	}
		return $response;
}
add_filter('process_braintree_donation_payment', 'process_braintree_donation_payment');

function check_braintree_donations_license(){
	$license = get_braintree_payments_config('braintree_payments_license');
	$license_status = get_braintree_payments_config('braintree_payments_license_status');
	$next_check = get_braintree_payments_config('braintree_next_license_check');
	if(! BRAINTREE_LICENSE_ACTIVATION_URL){
		define('BRAINTREE_LICENSE_ACTIVATION_URL', 'http://www.wordpresspayments.co/');
	}
	if($next_check < time()){
	
	$api_params = array('slm_action'=>'slm_check',
		'secret_key'=>BRAINTREE_LICENSE_VERIFICATION_KEY,
			'license_key'=>$license	
	 );
	$response = wp_remote_get(add_query_arg($api_params, BRAINTREE_LICENSE_ACTIVATION_URL), array('timeout' => 20, 'sslverify' => false));
	
	if(is_wp_error($response)){
		update_braintree_payments_config('braintree_next_license_check', (time()+ 60));
		$response = wp_remote_get(add_query_arg($api_params, BRAINTREE_LICENSE_ACTIVATION_URL), array('timeout' => 20, 'sslverify' => false));
		$response['body'] = json_decode($response['body']);
		if($response['body']->result == 'success'){
			update_braintree_payments_config('braintree_license_check_status', 'true');
			update_braintree_payments_config('braintree_payments_license_status', 'active');
		}
		else {
			update_braintree_payments_config('braintree_license_check_status', 'false');
			update_braintree_payments_config('braintree_payments_license_status', 'inactive');
		}
	}
	$response['body'] = json_decode($response['body']);
	if($response['body']->result == 'success'){
		update_braintree_payments_config('braintree_payments_license_status', 'active');
		update_braintree_payments_config('braintree_next_license_check', (time()+5*24*3600));
	}
	if($response['body']->result == 'error'){
		update_braintree_payments_config('braintree_payments_license_status', 'inactive');
	  }
    }
	
}
check_braintree_donations_license();
?>